【leetcode】1035. Uncrossed Lines

題目以下:app

We write the integers of A and B (in the order they are given) on two separate horizontal lines.this

Now, we may draw connecting lines: a straight line connecting two numbers A[i] and B[j] such that:spa

  • A[i] == B[j];
  • The line we draw does not intersect any other connecting (non-horizontal) line.

Note that a connecting lines cannot intersect even at the endpoints: each number can only belong to one connecting line.code

Return the maximum number of connecting lines we can draw in this way.blog

 

Example 1:it

Input: A = [1,4,2], B = [1,2,4] Output: 2 Explanation: We can draw 2 uncrossed lines as in the diagram. We cannot draw 3 uncrossed lines, because the line from A[1]=4 to B[2]=4 will intersect the line from A[2]=2 to B[1]=2. 

Example 2:io

Input: A = [2,5,1,2,5], B = [10,5,2,1,5,2] Output: 3 

Example 3:class

Input: A = [1,3,7,1,7,5], B = [1,9,2,5,1] Output: 2

 

Note:sed

  1. 1 <= A.length <= 500
  2. 1 <= B.length <= 500
  3. 1 <= A[i], B[i] <= 2000

解題思路:本題能夠採用動態規劃的方法。記dp[i][j]爲A[i]與B[j]連線後能夠組成的最多連線的數量,固然這裏A[i]與B[j]連線是虛擬的連線,所以存在A[i] != B[j]的狀況。首先來看A[i] == B[j],這說明A[i]與B[i]能夠連線,顯然有dp[i][j] = dp[i-1][j-1]+1;若是是A[i] != B[j],那麼分爲三種狀況dp[i][j] = max(dp[i-1][j-1],dp[i][j-1],dp[i-1][j]),這是由於A[i]不與B[j]連線,可是A[i]可能能夠與B[j]以前全部點的連線,同理B[j]也是同樣的。object

代碼以下:

class Solution(object): def maxUncrossedLines(self, A, B): """ :type A: List[int] :type B: List[int] :rtype: int """ dp = [] for i in range(len(A)): dp.append([0] * len(B)) for i in range(len(A)): for j in range(len(B)): if A[i] == B[j]: dp[i][j] = max(dp[i][j],1) if i - 1 >= 0 and j - 1 >= 0 : dp[i][j] = max(dp[i][j],dp[i-1][j-1]+1) else: if i - 1 >= 0 and j - 1 >= 0: dp[i][j] = max(dp[i][j],dp[i-1][j-1]) if j - 1 >= 0: dp[i][j] = max(dp[i][j],dp[i][j-1]) if i - 1 >= 0: dp[i][j] = max(dp[i][j],dp[i-1][j]) return dp[-1][-1]
相關文章
相關標籤/搜索